import type { Static } from "@sinclair/typebox"
import type { FastifyReply, FastifyRequest } from "fastify"
import type { PluginFastifyInstance } from "types"
import { Type } from "@sinclair/typebox"

const permissions = ["user.isAdmin"]

const ParamsSchema = Type.Object({
  _id: Type.String(),
})
type Params = Static<typeof ParamsSchema>

export default (fastify: PluginFastifyInstance) => {
  const accountService = fastify.custom.accountService

  const handler = async (
    req: FastifyRequest<{
      Params: Params
    }>,
    reply: FastifyReply,
  ) => {
    try {
      const { _id } = req.params

      const payload = await accountService.hardDeleteAccount(
        fastify,
        req.requestParams,
        _id,
      )

      return payload
    } catch (error: any) {
      fastify.log.error(error.message)
      return reply.internalServerError(error.message)
    }
  }

  return {
    handler,
    onRequest: [fastify.authenticate, fastify.checkPermissions(permissions)],
    config: {
      type: "dataHardDeleted",
      broadcastChannels: ["accountHardDeleted"],
    },
    schema: {
      summary: "Hard delete an account",
      description: "Permanently removes an account that has been soft deleted",
      tags: ["core/account"],

      params: ParamsSchema,
    },
  }
}
